Draft BSpline

From FreeCAD Documentation
This page is a translated version of the page Draft BSpline and the translation is 97% complete.
Outdated translations are marked like this.

Draft BSpline

Menüeintrag
Zeichnen → B-Spline
Arbeitsbereich
Draft, Arch
Standardtastenkürzel
B S
Eingeführt in Version
0.7
Siehe auch
Draft Polylinie, Draft Bézierkurve

Beschreibung

Der Befehl Draft B-Spline erstellt eine B-Spline-Kurve aus mehreren Punkten.

Der Befehl Draft B-Spline legt die exakten Punkte fest, durch die die Kurve verlaufen soll. Die Befehle Draft Bézierkurve und Draft KubischeBézierkurve verwenden andererseits Kontrollpunkte, um die Position und Krümmung des Splines zu definieren.

Spline festgelegt durch mehrere Punkte

Anwendung

Siehe auch: Draft Ablage, Draft Einrasten und Draft Beschränken.

  1. Es gibt mehrere Möglichkeiten, den Befehl aufzurufen:
  2. Die Schaltfläche BSpline drücken.
    • Den Menüeintrag Zeichnen → B-Spline auswählen.
    • Das Tastaturkürzel: B dann S.
  3. Der Aufgaben-Bereich B-spline wird geöffnet. Siehe Optionen für weitere Informationen.
  4. Den ersten Punkt in der 3D-Ansicht auswählen oder die Koordinaten eingeben und die Schaltfläche Punkt eingeben drücken.
  5. Weitere Punkte in der 3D-Ansicht auswählen oder Koordinaten eingeben und die Schaltfläche Punkt eingeben drücken.
  6. Esc oder die Schaltfläche Schließen drücken. um den Befehl zu beenden.

Optionen

Die im Aufgaben-Bereich vorhandenen Einzelzeichen-Tastaturkürzel können geändert werden. Siehe Draft-Einstellungen. Die hier genannten Tastaturkürzel sind die voreingestellten Tastaturkürzel (für Version 0.22).

  • Um die Koordinaten manuell einzugeben, werden die X-, Y- und Z-Komponente eingegeben und nach jeder Eingabe Eingabe (Enter) gedrückt. Man kann auch die Schaltfläche Punkt eingeben drücken, wenn die gewünschten Werte vorhanden sind.Es ist ratsam, vor der Eingabe der Koordinaten, den Mauszeiger aus der 3D-Ansicht heraus zu bewegen.
  • R drücken oder das Kontrollkästchen Relativ anklicken, um den Relativ-Modus umzuschalten. Wenn der Relativ-Modus eingeschaltet ist, sind die Koordinaten relativ zum letzten Punkt, falls vorhanden, ansonsten beziehen sie sich auf den Ursprung des Koordinatensystems.
  • G drücken oder das Kontrollkästchen Global anklicken, um den Global-Modus umzuschalten. Wenn der Global-Modus eingeschaltet ist, beziehen sich die Koordinaten auf das globale Koordinatensystem, ansonsten auf das Koordinatensystem der Arbeitsebene. eingeführt mit Version 0.20
  • F drücken oder das Kontrollkästchen Füllen anklicken, um den Füllmodus umzuschalten. Wenn der Füllmodus eingeschaltet ist, wird die Daten-EigenschaftMake Face der erstellten Kurve auf true gesetzt und die Kurve erhält eine gefüllte Fläche, vorausgesetzt, dass sie geschlossen ist und sich nicht selbst schneidet. Beachte, dass eine sich selbst schneidende Kurve mit einer Fläche nicht richtig angezeigt wird, für eine solche Kurve muss die Daten-EigenschaftMake Face auf false gesetzt werden.
  • N drücken oder das Kontrollkästchen Fortsetzen anklicken, um den Fortsetzungsmodus umzuschalten. Wenn der Fortsetzungsmodus eingeschaltet ist, wird der Befehl nach Betätigung von Fertigstellen oder Schließen, und auch nach dem Erstellen eines geschlossenen Splines, durch Einrasten auf den ersten Punkt des Splines, erneut gestartet, und es kann mit dem Erstellen von Splines fortgefahren werden.
  • / oder die Schaltfläche Rückgängig drücken, um den letzten Punkt rückgängig zu machen.
  • A oder die Schaltfläche Fertigstellen drücken, um den Befehl zu beenden und die Kurve offen zu lassen.
  • O oder die Schaltfläche Schließen drücken, um den Befehl zu beenden und den Spline zu schließen. Ein geschlossener Spline kann auch durch Einrasten auf den ersten Punkt des Splines erstellt werden.
  • W oder die Schaltfläche Radieren drücken, um die bereits positionierten Kurvenabschnitte zu löschen, aber vom letzten Punkt aus weiterzuarbeiten.
  • U oder die Schaltfläche Arbeitsebene festelegen drücken, um die aktuelle Arbeitsebene der durch den letzten und den vorherigen Punkt definierten Ausrichtung anzupassen.
  • S drücken, um Draft Einrasten ein- oder auszuschalten.
  • Esc oder die Schaltfläche Schliessen drücken, um den Befehl zu beenden.

Hinweise

Eigenschaften

Siehe auch: Eigenschafteneditor.

Ein Draft-B-Spline (BSpline-Objekt) wird von einem Part Part2DObject abgeleitet und erbt alle seine Eigenschaften. Außerdem hat es die folgenden zusätzlichen Eigenschaften:

Daten

Draft

  • Daten-EigenschaftArea (Area): (schreibgeschützt) gibt den Flächeninhalt der von dem Spline umschlossenen Fläche an. Der Wert ist 0.0, wenn Daten-EigenschaftMake Face auf false gesetzt ist oder die Fläche nicht erstellt werden kann.
  • Daten-EigenschaftClosed (Bool): gibt an, ob der Spline geschlossen ist oder nicht. Wenn der Spline anfänglich offen ist, ist dieser Wert false, wenn er auf true gesetzt wird, wird ein Kurvensegment gezeichnet, um den Spline zu schließen. Wenn der Spline anfänglich geschlossen ist, ist dieser Wert true, wenn man ihn auf false setzt, wird das letzte Kurvensegment entfernt und der Spline geöffnet.
  • Daten-EigenschaftMake Face (Bool): gibt an, ob der Spline eine Fläche bildet oder nicht. Wenn es true ist, wird eine Fläche erstellt, ansonsten wird nur der Umriss als Teil des Objekts betrachtet. Diese Eigenschaft funktioniert nur, wenn die Daten-EigenschaftClosed true ist und wenn der Spline sich nicht selbst schneidet.
  • Daten-EigenschaftParameterization (Float): beeinflusst die Form des Splines.
  • Daten-EigenschaftPoints (VectorList): gibt die Punkte des Splines in seinem lokalen Koordinatensystem an.

Ansicht

Draft

  • Ansicht-EigenschaftArrow Size (Length): legt die Größe des Symbols fest, das am Ende des Splines angezeigt wird.
  • Ansicht-EigenschaftArrow Type (Enumeration): gibt die Art des Symbols an, das am Ende des Splines angezeigt wird; es kann die Werte Dot, Circle, Arrow, Tick oder Tick-2 annehmen.
  • Ansicht-EigenschaftEnd Arrow (Bool): gibt an, ob am Ende des Splines ein Symbol angezeigt werden soll, damit er als Hinweislinie für Beschritung verwendet werden kann.
  • Ansicht-EigenschaftPattern (Enumeration): legt das Draft Muster fest, mit dem die Fläche des geschlossenen Splines gefüllt werden soll. Diese Eigenschaft funktioniert nur, wenn die Daten-EigenschaftMake Face auf true gesetzt und die Ansicht-EigenschaftDisplay Mode auf Flat Lines gesetzt ist.
  • Ansicht-EigenschaftPattern Size (Float): legt die Größe des Draft Musters fest.

Skripten

Siehe auch: Autogenerierte API-Dokumentation und FreeCAD Grundlagen Skripten.

Zum Erstellen eines Draft-B-Splines (BSpline-Objekt) wird die Methode make_bspline des Draft-Moduls verwendet (eingeführt mit Version 0.19). Diese Methode ersetzt die veraltete Methode makeBSpline.

bspline = make_bspline(pointslist, closed=False, placement=None, face=None, support=None)
bspline = make_bspline(Part.Wire, closed=False, placement=None, face=None, support=None)
  • Erstellt ein BSpline-Objekt mit der vorgegebenen Liste von Punkten, pointslist.
    • Jeder Punkt in der Liste wird durch seinen FreeCAD.Vector festgelegt, mit Einheiten in Millimetern.
    • Alternativ kann die Eingabe auch ein Part.Wire sein, aus dem Punkte extrahiert werden.
  • Ist closed auf True gesetzt, oder wenn der erste und letzte Punkt identisch sind, ist der Spline geschlossen.
  • Ist placement auf None gesetzt, wird der Spline am Ursprung erstellt.
  • Ist face auf True gesetzt, und der Spline geschlossen, ergibt der Spline eine Fläche, d. h. er erscheint gefüllt.

Beispiel:

import FreeCAD as App
import Draft

doc = App.newDocument()

p1 = App.Vector(0, 0, 0)
p2 = App.Vector(1000, 1000, 0)
p3 = App.Vector(2000, 0, 0)

spline1 = Draft.make_bspline([p1, p2, p3], closed=False)
spline2 = Draft.make_bspline([p1, 2*p3, 1.3*p2], closed=False)
spline3 = Draft.make_bspline([1.3*p3, p1, -1.7*p2], closed=False)

doc.recompute()